#!/usr/bin/python

#python script by Tak Lee for 2016 BIML network analysis 
#Usage: To predict candidate genes from input guide genes by direct neighborhood
#$python GBA_predict_genes.py [input guide genes] [input network] [input annotation terms] > [output file] 

import os,sys
from operator import itemgetter

score = {}


#read in guide genelists
guide_genes = [guides for guides in ((l.strip()) for l in open(sys.argv[1],'r'))]

#read in GOterms
goterms = {termgenes:terms for (termgenes,terms) in ((l2.strip()).split('\t') for l2 in open(sys.argv[3],'r'))}

#open network to find direct neighborhoods
network = {tuple(sorted((g1,g2))):s for (g1,g2,s) in ((l3.strip()).split('\t') for l3 in open(sys.argv[2],'r'))}
#sum up scores by guilt-by-association
for (g1,g2) in network:
	if g1 not in score:
		score[g1] = 0
	if g2 not in score:
		score[g2] = 0
	if g1 in guide_genes:
		score[g2] += float(network[(g1,g2)])
	if g2 in guide_genes:
		score[g1] += float(network[(g1,g2)])

#print out results
rank = 0
for candidate_gene,score in sorted(score.items(),key=itemgetter(1),reverse=True):
	if candidate_gene not in guide_genes:
		if(score > 0):
			rank+=1
			if candidate_gene in goterms:		
				print "%d\t%s\t%s\t%s" %(rank,str(candidate_gene),str(score),goterms[candidate_gene])
			else:
				print "%d\t%s\t%s\t%s" %(rank,str(candidate_gene),str(score),'NA')
	 
